de.caff.util

## Enum ParameterTypes

- java.lang.Object
- - java.lang.Enum<ParameterTypes>
  - - de.caff.util.ParameterTypes

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<ParameterTypes>

      public enum ParameterTypes
      extends java.lang.Enum<ParameterTypes>

  Types of parameters (Java properties) requested via utility class.
  Since:
    June 16, 2023
  Author:
    Rammi

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `Bool` Boolean parameter.
    `Color` Color parameter.
    `Double` Double parameter.
    `Enum` Enum parameter.
    `Float` Float parameter.
    `Int` Integer parameter.
    `Length` Length parameter.
    `Long` Long parameter.
    `String` String parameter.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Indexable<ParameterTypes>` | `VALUES` The values of this enum.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ParameterTypes` | `fromInternal(int internalValue)` Get the ParameterType enum associated with the given internal value.
    `static ParameterTypes` | `fromInternal(int internalValue, ParameterTypes defaultValue)` Get the ParameterType enum associated with the given internal value.
    `static ParameterTypes` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static ParameterTypes[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### String

          public static final ParameterTypes String

      String parameter. Requested by `Utility.getStringParameter(java.lang.String, java.lang.String)`

    - #### Bool

          public static final ParameterTypes Bool

      Boolean parameter. Requested by `Utility.getBooleanParameter(java.lang.String, boolean)` and `Utility.getBooleanParameter(java.lang.String, boolean, java.lang.String...)`.

    - #### Int

          public static final ParameterTypes Int

      Integer parameter. Requested by `Utility.getIntParameter(java.lang.String, int)` and `Utility.getIntParameter(java.lang.String, int, int)`.

    - #### Long

          public static final ParameterTypes Long

      Long parameter. Requested by `Utility.getLongParameter(java.lang.String, long)` and `Utility.getLongParameter(java.lang.String, long, int)`.

    - #### Double

          public static final ParameterTypes Double

      Double parameter. Requested by `Utility.getDoubleParameter(java.lang.String, double)`.

    - #### Float

          public static final ParameterTypes Float

      Float parameter. Requested by `Utility.getFloatParameter(java.lang.String, float)`.

    - #### Enum

          public static final ParameterTypes Enum

      Enum parameter. Requested by `Utility.getEnumParameter(java.lang.String, java.lang.Enum)`.

    - #### Color

          public static final ParameterTypes Color

      Color parameter. Requested by `Utility.getColorParameter(java.lang.String, java.awt.Color)`.

    - #### Length

          public static final ParameterTypes Length

      Length parameter. Requested by `Utility.getLengthParameter(java.lang.String, PhysicalLength)`.

  - ### Field Detail

    - #### VALUES

          @NotNull
          public static final Indexable<ParameterTypes> VALUES

      The values of this enum. Use this instead of `values()` because it does not require internal array copying.

  - ### Method Detail

    - #### values

          public static ParameterTypes[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ParameterTypes c : ParameterTypes.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ParameterTypes valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### fromInternal

          @Nullable
          public static ParameterTypes fromInternal(int internalValue)

      Get the ParameterType enum associated with the given internal value.
      Parameters:
        `internalValue` - internal value
      Returns:
        associated enum value, or `null` if there is none

    - #### fromInternal

          @NotNull
          public static ParameterTypes fromInternal(int internalValue,
                                                             @NotNull
                                                             ParameterTypes defaultValue)

      Get the ParameterType enum associated with the given internal value.
      Parameters:
        `internalValue` - internal value
        `defaultValue` - default value
      Returns:
        associated enum value, or `defaultValue` if there is none